unit hiSound;

interface

uses Kol,Share,Windows,Debug,MMSystem;

type
  TVolumeLevel = 0..127;
  THISound = class(TDebug)
   private
   public
    _prop_Freq:integer;
    _prop_Duration:integer;
    _prop_Volume:integer;
    _prop_Spectr:integer;
    _prop_SpectrVol:integer;
    _data_Duration:THI_Event;
    _data_Freq:THI_Event;
    _data_Volume:THI_Event;
    _data_Spectr:THI_Event;
    _data_SpectrVol:THI_Event;
    _event_onEnd:THI_Event;

    procedure _work_doBeep(var _Data:TData; Index:word);
    procedure _work_doMakeSound(var _Data:TData; Index:word);
  end;

implementation

procedure THISound._work_doBeep;
var fr,dr:integer;
begin
   fr := ReadInteger(_Data,_data_Freq,_prop_Freq);
   dr := ReadInteger(_Data,_data_Duration,_prop_Duration);
   if fr = 0 then sleep(dr) else Beep(fr,dr);
   _hi_OnEvent(_event_onEnd,0)
end;

procedure THISound._work_doMakeSound;
{writes tone to memory and plays it}
var
  WaveFormatEx: TWaveFormatEx;
  MS: PStream;
  i, TempInt, DataCount, RiffCount, Frequency, Duration: integer;
  SoundValue, SpectrA, SpectrVolA: byte;
  VolumeA, w, w05, w2x05: double; // omega ( 2 * pi * frequency)
  Volume: TVolumeLevel;
const
  Mono: Word = $0001;
  SampleRate: Integer = 44100; // 8000, 11025, 22050, or 44100
  RiffId: string = 'RIFF';
  WaveId: string = 'WAVE';
  FmtId: string = 'fmt ';
  DataId: string = 'data';
begin
  Frequency:=ReadInteger(_Data,_data_Freq,_prop_Freq);
  Duration:=ReadInteger(_Data,_data_Duration,_prop_Duration);
  Volume:=ReadInteger(_Data,_data_Volume,_prop_Volume);
  SpectrA:=Readinteger(_Data,_data_Spectr,_prop_Spectr+1);
  SpectrVolA:=Readinteger(_Data,_data_SpectrVol,_prop_SpectrVol+1);
  with WaveFormatEx do
  begin
    wFormatTag := WAVE_FORMAT_PCM;
    nChannels := Mono;
    nSamplesPerSec := SampleRate;
    wBitsPerSample := $0008;
    nBlockAlign := (nChannels * wBitsPerSample) div 8;
    nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
    cbSize := 0;
  end;
    DataCount := (Duration * SampleRate) div 1000;
    RiffCount := Length(WaveId) + Length(FmtId) + SizeOf(DWORD) + SizeOf(TWaveFormatEx) + Length(DataId) + SizeOf(DWORD) + DataCount;
    MS:=NewMemoryStream;
    MS.Write(RiffId[1], 4);
    MS.Write(RiffCount, SizeOf(DWORD));
    MS.Write(WaveId[1], Length(WaveId));
    MS.Write(FmtId[1], Length(FmtId));
    TempInt := SizeOf(TWaveFormatEx);
    MS.Write(TempInt, SizeOf(DWORD));
    MS.Write(WaveFormatEx, SizeOf(TWaveFormatEx));
    MS.Write(DataId[1], Length(DataId));
    MS.Write(DataCount, SizeOf(DWORD));
    w05 := SampleRate/(2 * Frequency);
    w2x05 := 2 * w05;
    w := 2 * Pi * Frequency/ SampleRate;
    for i := 0 to DataCount - 1 do
    begin
       VolumeA := Volume;
      case SpectrVolA of
         1:;
         2: VolumeA := Volume  /Exp((i DIV trunc(w05))/300);
         3: VolumeA := Volume * (1 - 1/Exp((i DIV trunc(w05))/100));
         4: VolumeA := Volume * 2* (1 - 1/Exp((i DIV trunc(w05))/100))/Exp((i DIV trunc(w05))/300);
      end;
      case SpectrA of
        1: SoundValue := 127 + trunc(VolumeA * sin(i * w ));
        2: SoundValue := 127 + trunc(VolumeA * 0.68*(sin(i * w)+ 0.9*sin(i * 3 * w)));
        3:
           begin
             if Odd(i DIV trunc(w05)) then
               SoundValue := 127 + trunc(VolumeA)
             else
               SoundValue := 127 - trunc(VolumeA);
           end;
        4: SoundValue := 127 + trunc(VolumeA * cos(i mod trunc(w2x05)*0.5*w));//* 255/w2x05)-127);
        5: SoundValue := 127 + trunc(VolumeA * (sin(i * w )+ 0.4*(sin(i * w * 1.005 )+ sin(i * w * 0.995)))/1.8);
      end;
      MS.Write(SoundValue, SizeOf(Byte));
    end;

    sndPlaySound(MS.Memory, SND_MEMORY or SND_SYNC);
    MS.Free;
    _hi_OnEvent(_event_onEnd,SpectrA)
end;


end.
